function [X,Y] = readData(dataset)
% readData returns training data
% 
% Usage:
%   [X,Y] = readData(dataset)
%
% Input:
%   dataset : (Required) String
%       Current supported datasets are:
%           'toy'    : toy dataset for hw3
%           'boston' : The Boston Housing Dataset
%           'iris'   : Iris DataSet
%
% Return:
%    X : Array
%       input data
%    Y : Array
%       label/groundtruth of input data
% Note:
%   * By convention, the last dimension indicates the index of sample, 
%     i.e., X(:,1) stands for the first sample.
    import Dataloader.*
    
    dataset = lower(dataset);
    
    readerLists = struct(...
        'toy',@readData_toy,...
        'boston',@readData_boston,...
        'iris',@readData_iris);
    
    readData_ = readerLists.(dataset);
    [X,Y] = readData_();
end