function Y = forward(X,W,b, ActivationFunction)
    ActivationFunctionList = struct(...
        'logistic', @logistic,...
        'tanh', @tanh,...
        'relu', @relu);
    phi = ActivationFunctionList.(lower(ActivationFunction));
    
    W = [W;b'];
    X = [X; ones(1,size(X,2))];
    
    V = W' * X;
    Y = phi(V);
end

function y = logistic(x)
    y = 1 ./ (1 + exp(-x));
end

function y = relu(x)
    y = max(0,x);
end

function y = tanh(x)
    y = (exp(2*x)-1)./(exp(2*x)+1);
end