function [loss, Y_hat] = forwardLoss(X,Y,W,b, ActivationFunction, LossCriterion)
    import TrainingUtils.forward
    
    LossCriterionList = struct(...
        'mse', @meanSquaredError,...
        'mae', @meanAbsoluteError);
    getLoss = LossCriterionList.(lower(LossCriterion));
    
    Y_hat = forward(X,W,b, ActivationFunction);
    loss = getLoss(Y, Y_hat);
end

function loss = meanSquaredError(Y,T)
    squares = 0.5*(Y-T).^2;
    loss = mean(sum(squares,1));
end

function loss = meanAbsoluteError(Y,T)
    loss = mean(sum(abs(Y-T),1));
end