# 作业三参考答案 （深度学习2018秋）

在作业的原始代码`hw3_template.m`上进行调整与修改。为了让代码更具有可读性，将函数分开写到不同的文件中。

* 网络层
    - 线性函数: 添加偏置项，即将`W' * x`改为`W' * x + b`
    	修改了`forward`以及`backwardLoss`函数
    	将`W' * x +b`合并(zip)为等价的`[W;b']' * [X;ones(1,size(X,2))]`问题，再拆分（unzip)
    - 激活函数: tanh
    	修改了`forward`以及`backwardLoss`函数
    - 激活函数: relu
    	修改了`forward`以及`backwardLoss`函数
    - 损失函数: mae(mean-absolute-error)
    	修改了`forwardLoss`以及`backwardLoss`函数
    - 算法加速: 重写`backwardLoss`，将`for`循环去掉
    	通过矩阵转置来实现sum，保证维度匹配即可
* 优化算法
    - 梯度裁剪(gradient clipping)
    	修改了`update`函数。这不是一个特别严格的理论，存在多种常用的梯度裁剪的方式，只需要符合“梯度裁剪”这个idea即可。
    - minibatch SGD
    	在`trainNetwork`函数中新增一个`generateBatchIndices`，将下标打乱之后再按顺序读取即可（在epoch循环的基础上又增加了一层循环）
    - 带动量的随机梯度下降sgdm (SGD with momentum)
    	修改了`update`函数，需要注意的是`cache`必须在整个训练过程开始前（在`trainNetwork`内）进行初始化（每一次调用`update`都进行一次初始化的方式是错误的）
    - ADAM
    	同上
    - Adagrad
    	同上
    - RMSprop
    	同上
* 数据集
    - 写一个[iris数据集](https://archive.ics.uci.edu/ml/datasets/iris)的读取函数
    为了让hw3的激活函数（值域为[0,1])能够训练该数据集，将三类iris分别转换为{0,0.5,1}，但是这种编码方式是有问题的，因为它认为第一类与第三类的差别比第二类与第三类的差别要大。
    - 训练iris数据集

    
## 注

* 为了让代码兼容不同的实现方式并且保留清晰的代码结构，使用了很多类似于

	```matlab
	function Y = forward(X,W,b, ActivationFunction)
	    ActivationFunctionList = struct(...
	        'logistic', @logistic,...
	        'tanh', @tanh,...
	        'relu', @relu);
	    phi = ActivationFunctionList.(lower(ActivationFunction));
	    
	    W = [W;b'];
	    X = [X; ones(1,size(X,2))];
	    
	    V = W' * X;
	    Y = phi(V);
	end
	```
	
	的代码，通过这种方式，`forward`里只**抽象地**实现了算法的逻辑结构，而将具体的`phi`的实现留给特定的函数块。`ActivationFunctionList`实际上就是最简单的**注册表 (Registry)**。
	
* 若学习率过大，则`W' * X + b`很可能返回的是负值，通过`relu`之后值变为0，从而导致接下来的梯度恒为0，这种现象叫做**dead neurons**。一般来说将初始学习率调低，或者改用`leaky relu` 或者`prelu`都可以解决该问题。

* 对于Boston房价数据集，如果采用`logistic`或`tanh`激活函数，会导致值域在`[0,1]`之间，而房价的范围大约在`[50,300]`之间，因此必须采用`relu`才能够正常地拟合该问题。 实际上，一般来说一个深度网络的最后一层都是单独的线性层（不加激活函数），因为激活函数在一定程度上扭曲了最终的拟合结果。