import Dataloader.* TrainingUtils.*
[X,Y] = readData('toy'); % 'toy', 'boston', 'iris'
% X = normalize(X,1); % normalization is necessary for boston/iris
[W,b] = initializeNetwork(size(X,1),size(Y,1));

Optimizer = struct(...
    'solver', 'sgdm',... % 'sgd', 'sgdm', 'adam', 'rmsprop', 'adagrad'
    'GradientClipThreshold', Inf,... % Inf, 1, 0.1
    'sgdm_momentum', 0.9,... % 0.9, 0.99, 0.999
    'adam_beta1',0.9,... % 0.9, 0.99, 0.999
    'adam_beta2', 0.999,... % 0.999
    'rms_decayrate',0.9); % 0.9, 0.99, 0.999
trainingOptions = struct(...
    'ActivationFunction', 'logistic',... % 'relu', 'logistic', 'tanh'
    'LossCriterion', 'mse',... % 'mae', 'mse'
    'Optimizer', Optimizer,... 
    'InitialLearnRate', 1e-1, ... % use small learn rate to avoid dead neurons for relu
    'BatchSize', 2,...
    'LearnRateDropPeriod', 7000, ...
    'MaxEpoch',10000, ...
    'LearnRateDropFactor', 0.1, ...
    'Verbose', true, ...
    'Shuffle', true, ...
    'VerboseFrequency', 50);

[W,b] = trainNetwork(X, Y, W, b, trainingOptions);
Y_hat = predict(X,W,b, trainingOptions.ActivationFunction);

% show results
n = size(X,2);
plot(1:n, Y,'ro',...
    1:n, Y_hat,'b+');
xlabel('x');ylabel('y');title('prediction');